Skip to main content
`Ctrl`+`K`

# numpy.ndindex

class numpy.ndindex(*shape)

  An N-dimensional iterator object to index arrays.

  Given the shape of an array, an `ndindex` instance iterates over the N-dimensional index of the array. At each iteration a tuple of indices is returned, the last dimension is iterated over first.

  Parameters:
    shape ints, or a single tuple of ints

      The size of each dimension of the array can be passed as individual parameters or as the elements of a tuple.

  Methods

  `ndincr`() | Increment the multi-dimensional index by one.

  See also

  `ndenumerate`, `flatiter`

  Examples

      >>> import numpy as np

  Dimensions as individual arguments

      >>> for index in np.ndindex(3, 2, 1):
      ...     print(index)
      (0, 0, 0)
      (0, 1, 0)
      (1, 0, 0)
      (1, 1, 0)
      (2, 0, 0)
      (2, 1, 0)

  Same dimensions - but in a tuple `(3, 2, 1)`

      >>> for index in np.ndindex((3, 2, 1)):
      ...     print(index)
      (0, 0, 0)
      (0, 1, 0)
      (1, 0, 0)
      (1, 1, 0)
      (2, 0, 0)
      (2, 1, 0)